## oci-image-tools 1.0.0~rc2+really.rc1+dfsg

=== Makefile ===
PREFIX ?= $(DESTDIR)/usr
BINDIR ?= $(DESTDIR)/usr/bin

COMMIT=$(shell git rev-parse HEAD 2> /dev/null || true)
EPOCH_TEST_COMMIT ?= $(shell git tag | tail -1)

default: all

help:
	@echo "Usage: make <target>"
	@echo
	@echo " * 'all' - Build the oci tool and manual pages"
	@echo " * 'tool' - Build the oci tool"
	@echo " * 'install' - Install binaries and manual pages"
	@echo " * 'install.tools' - Install tool needed for building this project"
	@echo " * 'uninstall' - Remove the oci tool and manual pages"
	@echo " * 'man' - Build the oci image manual pages"
	@echo " * 'check-license' - Check license headers in source files"
	@echo " * 'lint' - Execute the source code linter"
	@echo " * 'test' - Execute the unit tests"
	@echo " * 'update-deps' - Update vendored dependencies"
	@echo " * 'clean' - clean existing build artifacts"

check-license:
	@echo "checking license headers"
	@./.tool/check-license

.PHONY: tool
tool:
	go build -ldflags "-X main.gitCommit=${COMMIT}" -o oci-image-tool ./cmd/oci-image-tool


all: tool man

.PHONY: man
man:
	go-md2man -in "man/oci-image-tool.1.md" -out "oci-image-tool.1"
	go-md2man -in "man/oci-image-tool-create.1.md" -out "oci-image-tool-create.1"
	go-md2man -in "man/oci-image-tool-unpack.1.md" -out "oci-image-tool-unpack.1"
	go-md2man -in "man/oci-image-tool-validate.1.md" -out "oci-image-tool-validate.1"


install: man
	install -d -m 755 $(BINDIR)
	install -m 755 oci-image-tool $(BINDIR)
	install -d -m 755 $(PREFIX)/share/man/man1
	install -m 644 *.1 $(PREFIX)/share/man/man1
	install -d -m 755 $(PREFIX)/share/bash-completion/completions
	install -m 644 completions/bash/oci-image-tool $(PREFIX)/share/bash-completion/completions

uninstall:
	rm -f $(BINDIR)/oci-image-tool
	rm -f $(PREFIX)/share/man/man1/oci-image-tool*.1
	rm -f $(PREFIX)/share/bash-completion/completions/oci-image-tool

lint:
	@echo "checking lint"
	@./.tool/lint

.PHONY: .gofmt .govet .gotest

PACKAGES = $(shell go list ./... | grep -v /vendor/)
test: .gofmt .govet .gotest

FILES = $(shell find ./ -name *.go | grep -v vendor)
.gofmt:
	OUT=$$(gofmt -s -d $(FILES)); if test -n "$${OUT}"; then echo "$${OUT}" && exit 1; fi

.govet:
	go vet -x $(PACKAGES)

.gotest:
	go test -v -race -cover $(PACKAGES)


## this uses https://github.com/Masterminds/glide and https://github.com/sgotti/glide-vc
update-deps:
	@which glide > /dev/null 2>/dev/null || (echo "ERROR: glide not found. Consider 'make install.tools' target" && false)
	glide update --strip-vcs --strip-vendor --update-vendored --delete
	glide-vc --only-code --no-tests
	# see http://sed.sourceforge.net/sed1line.txt
	find vendor -type f -exec sed -i -e :a -e '/^\n*$$/{$$d;N;ba' -e '}' "{}" \;

.PHONY: .gitvalidation

# When this is running in travis, it will only check the travis commit range
.gitvalidation:
	@which git-validation > /dev/null 2>/dev/null || (echo "ERROR: git-validation not found. Consider 'make install.tools' target" && false)
ifeq ($(TRAVIS),true)
	git-validation -q -run DCO,short-subject,dangling-whitespace
else
	git-validation -v -run DCO,short-subject,dangling-whitespace -range $(EPOCH_TEST_COMMIT)..HEAD
endif

.PHONY: install.tools

install.tools: .install.gitvalidation .install.glide .install.glide-vc .install.gometalinter .install.go-md2man

.install.gitvalidation:
	go get github.com/vbatts/git-validation

.install.glide:
	go get github.com/Masterminds/glide

.install.glide-vc:
	go get github.com/sgotti/glide-vc

.install.gometalinter:
	go get github.com/alecthomas/gometalinter
	gometalinter --install --update

.install.go-md2man:
	go get github.com/cpuguy83/go-md2man

clean:
	rm -rf oci-image-tool *.1

.PHONY: \
	all \
	tool \
	man \
	install \
	uninstall \
	check-license \
	clean \
	lint \
	test

=== debian/changelog ===
oci-image-tools (1.0.0~rc2+really.rc1+dfsg-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Reinhard Tartler ]
  * fix autopkg test by avoiding dependency on outdated bzip2 compressor

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 15 Dec 2020 12:55:10 -0500

oci-image-tools (1.0.0~rc2+really.rc1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #900900).

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 07 Jun 2018 01:01:20 +1000

=== debian/control ===
Source: oci-image-tools
Section: devel
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper-compat (= 12),dh-golang,
               golang-any
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev
    ,golang-github-opencontainers-specs-dev
    ,golang-github-pkg-errors-dev
    ,golang-github-sirupsen-logrus-dev
    ,golang-github-urfave-cli-dev
    ,go-md2man
    ,bash-completion
Standards-Version: 4.1.4
Homepage: https://github.com/opencontainers/image-tools
Vcs-Browser: https://salsa.debian.org/go-team/packages/oci-image-tools
Vcs-Git: https://salsa.debian.org/go-team/packages/oci-image-tools.git
XS-Go-Import-Path: github.com/opencontainers/image-tools
Testsuite: autopkgtest-pkg-go

Package: oci-image-tool
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: OCI image tooling
 oci-image-tool is a collection of tools for working with the OCI image
 format specification (https://github.com/opencontainers/image-spec).

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_build:
	dh_auto_build
	$(MAKE) man

override_dh_auto_install:
	dh_auto_install -- --no-source

%:
	dh $@ --buildsystem=golang --with=golang,bash-completion

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s{[+~]dfsg\d*}{},\
uversionmangle=s{\-[Rr][Cc]}{~rc},\
" https://github.com/opencontainers/image-tools/releases \
  .*/archive/v?(\d[\d\.\-rc]+)\.tar\.gz
